/* 
Scrivere un metodo statico 
ArrayList<Integer> inverti(ArrayList<Integer> a) 
che prende un oggetto ArrayList<Integer> e ne inverte
lordine degli elementi.

Write a Java method  ArrayList<Integer> inverti(ArrayList<Integer> a) 
which, given an ArrayList <Integer> object, reverses the order of its elements
*/

import java.util.*;

public class InvertiArray {

	//Procedura inefficiente
	public static ArrayList<Integer> inverti(ArrayList<Integer> a){
	ArrayList<Integer> temp=new ArrayList<Integer>();
	Iterator<Integer> itr = a.iterator();
	while (itr.hasNext()){
		temp.add(0,itr.next()); //quanto costa?
	}
	 return temp;
	}

	
	//Talvolta l'accesso diretto pu essere piu' essere pi efficiente
	public static ArrayList<Integer> inverti2(ArrayList<Integer> a){
	ArrayList<Integer> temp = new ArrayList<Integer>();
	int size = a.size();
	for (int i = 0 ; i < size; i++) 
		temp.add(i, a.get(size-i-1));
	
	 return temp;
	}
	
	
	  public static void main (String[ ] args) {
		  ArrayList<Integer> Alist = new ArrayList<Integer>();
		  List<Integer> out;
		  Alist.add(345);
		  Alist.add(12);
		  Alist.add(55);
		  out = inverti2(Alist);
		  System.out.println(Alist);
		  System.out.println(out);
		  
	  }
}