/* ESERCITAZIONE: 
 * integrazione della classe RandomList con:
 * 4) cancellazione di elementi dalla lista (uso degli iteratori)
 * 5) ordinamento naturale
  */


import java.util.*;


public class RandomList2 {

  public static void main (String[ ] args) {
     new RandomList2().run();
  } // method main


  public void run(){
     List<Integer> randList = new ArrayList<Integer>();
     final int L = 50;
      
        Random r = new Random();
      
        // 1) Insert L random integers, in the range 0...99, into randList:
        for (int i = 0; i < L; i++)
             randList.add (r.nextInt(100)); // insertion
      
        // 2) Print out randList:
        System.out.println ("\nRandom List:\t" + randList);  
      
	// 3) Verify if this list contains the specified element.
	System.out.print ("\nSee if 22 is in randList:\t");
        if (randList.contains (22))
             System.out.println ("Yes, 22 is in randList.");
        else System.out.println ("No, 22 is not in randList.");
      

        System.out.println (randList.get (3) + " is at index 3");
      
        System.out.println ("\nRemove the integer " + randList.get (6) + " at index 6.");
	randList.remove (6);

        System.out.println ("\nInsert a new random integer at index 5.");
        randList.add (5, r.nextInt (100));

        // Print out randList.
        System.out.println (randList);
        

	/* 4) Remove all even integers      */
        System.out.println ("\nRemove all even integers and sort.");
        Iterator<Integer> itr = randList.iterator();
        while (itr.hasNext())        
             if (itr.next() % 2 == 0)
                 itr.remove();
               
         // Print out randList;
        Collections.sort(randList);
         System.out.println (randList); 


	/* 4) REMARK: Remove all odd integers      
        for(Integer x: randList)
             if ((int)x % 2 == 1)  
                  //not allowed
		  randList.remove(x); */
               

        
 } // method run

} // class RandomList2
